## wl-mirror 0.13.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

project(wl-mirror C)

# options
option(INSTALL_EXAMPLE_SCRIPTS "install wl-mirror example scripts" OFF)
option(INSTALL_DOCUMENTATION "install wl-mirror manual pages" OFF)

# wayland protocols needed by wl-mirror
option(FORCE_SYSTEM_WL_PROTOCOLS "force use of system wayland-protocols" OFF)
option(FORCE_SYSTEM_WLR_PROTOCOLS "force use of system wlr-protocols" OFF)
set(WL_PROTOCOL_DIR "/usr/share/wayland-protocols/" CACHE STRING "wayland-protocols directory")
set(WLR_PROTOCOL_DIR "/usr/share/wlr-protocols/" CACHE STRING "wlr-protocols directory")
set(PROTOCOLS
    "stable/xdg-shell/xdg-shell.xml"
    "unstable/xdg-output/xdg-output-unstable-v1.xml"
    "unstable/linux-dmabuf/linux-dmabuf-unstable-v1.xml"
    "unstable/wlr-export-dmabuf-unstable-v1.xml"
    "unstable/wlr-screencopy-unstable-v1.xml"
)

# required dependencies
add_subdirectory(deps)

# wayland protocol wrapper generation with wayland-scanner
add_subdirectory(proto)

# shader file embedding
add_subdirectory(glsl)

# version embedding
add_subdirectory(version)

# manual pages
add_subdirectory(man)
if (${BUILD_DOCUMENTATION})
    build_scdoc_man_page(wl-mirror 1)
    build_scdoc_man_page(wl-present 1)
endif()

# main target
file(GLOB sources src/*.c)
add_executable(wl-mirror ${sources})
target_compile_options(wl-mirror PRIVATE -Wall -Wextra)
target_include_directories(wl-mirror PRIVATE include/)
target_link_libraries(wl-mirror PRIVATE deps protocols shaders version)

# installation rules
include(GNUInstallDirs)

install(TARGETS wl-mirror DESTINATION "${CMAKE_INSTALL_BINDIR}")
if (${INSTALL_EXAMPLE_SCRIPTS})
    install(PROGRAMS scripts/wl-present DESTINATION "${CMAKE_INSTALL_BINDIR}")
endif()

if (${INSTALL_DOCUMENTATION})
    install_scdoc_man_page(wl-mirror 1)
    if (${INSTALL_EXAMPLE_SCRIPTS})
        install_scdoc_man_page(wl-present 1)
    endif()
endif()

=== deps/CMakeLists.txt ===
find_package(PkgConfig REQUIRED)

add_library(deps INTERFACE)
add_library(proto_deps INTERFACE)

# helper function for finding one of a list of packages
function(do_pkg_search_module name)
    pkg_search_module(${name} ${ARGN})

    set(module_name "${${name}_MODULE_NAME}")
    set(module_version "${${name}_VERSION}")
    message(STATUS "  Found ${module_name}, version ${module_version}")
endfunction()

# required dependencies
pkg_check_modules(WaylandClient REQUIRED IMPORTED_TARGET "wayland-client")
pkg_check_modules(WaylandEGL REQUIRED IMPORTED_TARGET "wayland-egl")
pkg_check_modules(EGL REQUIRED IMPORTED_TARGET "egl")
pkg_check_modules(GLESv2 REQUIRED IMPORTED_TARGET "glesv2")
pkg_check_modules(WaylandScanner REQUIRED "wayland-scanner")
pkg_get_variable(WAYLAND_SCANNER "wayland-scanner" "wayland_scanner")
set(WAYLAND_SCANNER "${WAYLAND_SCANNER}" PARENT_SCOPE)

# man dependencies
if (${INSTALL_DOCUMENTATION})
    pkg_check_modules(SCDOC REQUIRED "scdoc")
else()
    pkg_check_modules(SCDOC "scdoc")
endif()
pkg_get_variable(SCDOC "scdoc" "scdoc")
set(SCDOC "${SCDOC}" PARENT_SCOPE)

# link dependencies
target_link_libraries(deps INTERFACE
    PkgConfig::WaylandClient PkgConfig::WaylandEGL PkgConfig::EGL PkgConfig::GLESv2
)
target_link_libraries(proto_deps INTERFACE
    PkgConfig::WaylandClient
)

=== glsl/CMakeLists.txt ===
add_library(shaders STATIC)
target_include_directories(shaders INTERFACE "${CMAKE_CURRENT_BINARY_DIR}/include/")
file(GLOB shaders "*.glsl")
foreach(shader ${shaders})
    get_filename_component(shader-base "${shader}" NAME_WE)

    set(shader-template "${CMAKE_CURRENT_SOURCE_DIR}/embed.c.in")
    set(shader-header "${CMAKE_CURRENT_BINARY_DIR}/include/glsl_${shader-base}.h")
    set(shader-source "${CMAKE_CURRENT_BINARY_DIR}/src/glsl_${shader-base}.c")

    message(STATUS "embedding ${shader-base}.glsl")

    add_custom_command(
        OUTPUT "${shader-source}"
        MAIN_DEPENDENCY "${shader}"
        COMMAND "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_SOURCE_DIR}/embed.cmake" "${shader}" "${shader-template}" "${shader-source}"
    )
    add_custom_target(gen-${shader-base} DEPENDS "${shader-source}")

    set(FILENAME "${shader-base}")
    set(DATA "${shader-data}")
    configure_file(embed.h.in "${shader-header}" @ONLY)

    set_source_files_properties("${shader-header}" PROPERTIES GENERATED 1)
    set_source_files_properties("${shader-source}" PROPERTIES GENERATED 1)

    add_dependencies(shaders gen-${shader-base})
    target_sources(shaders PRIVATE "${shader-source}")
endforeach()

=== man/CMakeLists.txt ===
# determine if documentation can be built
if (${SCDOC_FOUND})
    set(BUILD_DOCUMENTATION ON PARENT_SCOPE)
else()
    set(BUILD_DOCUMENTATION OFF PARENT_SCOPE)
endif()


function(build_scdoc_man_page name section)
    file(MAKE_DIRECTORY "${CMAKE_BINARY_DIR}/man/")
    set(man-src "${CMAKE_SOURCE_DIR}/man/${name}.${section}.scd")
    set(man-bin "${CMAKE_BINARY_DIR}/man/${name}.${section}")
    add_custom_command(
        OUTPUT "${man-bin}"
        COMMAND "${SCDOC}" < "${man-src}" > "${man-bin}"
    )
    add_custom_target(gen-man-${name}-${section} ALL DEPENDS "${man-bin}")
endfunction()

function(install_scdoc_man_page name section)
    set(man-bin "${CMAKE_BINARY_DIR}/man/${name}.${section}")
    install(FILES "${man-bin}" DESTINATION "${CMAKE_INSTALL_MANDIR}/man${section}/")
endfunction()

=== debian/changelog ===
wl-mirror (0.13.2-1) unstable; urgency=medium

  * Document --freeze options in the manual pages
  * Fix typos in debug log messages

 -- Ferdinand Bachmann <ferdinand.bachmann@yrlf.at>  Fri, 11 Aug 2023 14:09:58 +0200

wl-mirror (0.13.1-1) unstable; urgency=medium

  * Initial release (Closes: #1012684)

 -- Ferdinand Bachmann <ferdinand.bachmann@yrlf.at>  Thu, 16 Mar 2023 16:23:42 +0000

## wl-mirror 0.16.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -14,6 +14,8 @@
 set(WLR_PROTOCOL_DIR "/usr/share/wlr-protocols/" CACHE STRING "wlr-protocols directory")
 set(PROTOCOLS
     "stable/xdg-shell/xdg-shell.xml"
+    "stable/viewporter/viewporter.xml"
+    "staging/fractional-scale/fractional-scale-v1.xml"
     "unstable/xdg-output/xdg-output-unstable-v1.xml"
     "unstable/linux-dmabuf/linux-dmabuf-unstable-v1.xml"
     "unstable/wlr-export-dmabuf-unstable-v1.xml"
@@ -40,7 +42,7 @@
 endif()
 
 # main target
-file(GLOB sources src/*.c)
+file(GLOB sources CONFIGURE_DEPENDS src/*.c)
 add_executable(wl-mirror ${sources})
 target_compile_options(wl-mirror PRIVATE -Wall -Wextra)
 target_include_directories(wl-mirror PRIVATE include/)

=== deps/CMakeLists.txt ===
--- 
+++ 
@@ -13,6 +13,7 @@
 endfunction()
 
 # required dependencies
+find_library(MATH_LIBRARY m REQUIRED)
 pkg_check_modules(WaylandClient REQUIRED IMPORTED_TARGET "wayland-client")
 pkg_check_modules(WaylandEGL REQUIRED IMPORTED_TARGET "wayland-egl")
 pkg_check_modules(EGL REQUIRED IMPORTED_TARGET "egl")
@@ -32,8 +33,18 @@
 
 # link dependencies
 target_link_libraries(deps INTERFACE
+    ${MATH_LIBRARY}
     PkgConfig::WaylandClient PkgConfig::WaylandEGL PkgConfig::EGL PkgConfig::GLESv2
 )
 target_link_libraries(proto_deps INTERFACE
     PkgConfig::WaylandClient
 )
+
+# check for epoll support in libc
+include(CheckSymbolExists)
+check_symbol_exists("epoll_wait" "sys/epoll.h" has-epoll)
+if(NOT has-epoll)
+    # use epoll-shim to provide epoll
+    pkg_check_modules(EPoll REQUIRED IMPORTED_TARGET "epoll-shim")
+    target_link_libraries(deps INTERFACE PkgConfig::EPoll)
+endif()

=== glsl/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 add_library(shaders STATIC)
 target_include_directories(shaders INTERFACE "${CMAKE_CURRENT_BINARY_DIR}/include/")
-file(GLOB shaders "*.glsl")
+file(GLOB shaders CONFIGURE_DEPENDS "*.glsl")
 foreach(shader ${shaders})
     get_filename_component(shader-base "${shader}" NAME_WE)

=== proto/CMakeLists.txt ===
# detect wayland-protocols location
set(wl-protocols-found FALSE)
if(NOT ${FORCE_SYSTEM_WL_PROTOCOLS} AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/wayland-protocols/.git")
    message(STATUS "using wayland-protocols from submodule")
    set(WL_PROTOCOL_DIR "${CMAKE_CURRENT_SOURCE_DIR}/wayland-protocols/")
    set(wl-protocols-found TRUE)
endif()

if (NOT ${wl-protocols-found} AND IS_DIRECTORY ${WL_PROTOCOL_DIR})
    message(STATUS "using system wayland-protocols at ${WL_PROTOCOL_DIR}")
    set(wl-protocols-found TRUE)
endif()

if (NOT ${wl-protocols-found})
    message(STATUS "error: wayland-protocols not found")
endif()

# detect wlr-protocols location
set(wlr-protocols-found FALSE)
if(NOT ${FORCE_SYSTEM_WLR_PROTOCOLS} AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/wlr-protocols/.git")
    message(STATUS "using wlr-protocols from submodule")
    set(WLR_PROTOCOL_DIR "${CMAKE_CURRENT_SOURCE_DIR}/wlr-protocols/")
    set(wlr-protocols-found TRUE)
endif()

if (NOT ${wlr-protocols-found} AND IS_DIRECTORY ${WLR_PROTOCOL_DIR})
    message(STATUS "using system wlr-protocols at ${WLR_PROTOCOL_DIR}")
    set(wlr-protocols-found TRUE)
endif()

if (NOT ${wlr-protocols-found})
    message(STATUS "error: wlr-protocols not found")
endif()

if (NOT ${wl-protocols-found} OR NOT ${wlr-protocols-found})
    message(FATAL_ERROR "wayland-protocols or wlr-protocols not found")
endif()

# wayland protocol wrapper generation with wayland-scanner
set(protocols-found TRUE)
add_library(protocols STATIC)
target_include_directories(protocols INTERFACE "${CMAKE_CURRENT_BINARY_DIR}/include/")
target_link_libraries(protocols PRIVATE proto_deps)
foreach(proto ${PROTOCOLS})
    get_filename_component(proto-base "${proto}" NAME_WE)
    set(wl-proto-file "${WL_PROTOCOL_DIR}/${proto}")
    set(wlr-proto-file "${WLR_PROTOCOL_DIR}/${proto}")

    if(EXISTS ${wl-proto-file})
        message(STATUS "using ${proto} from wayland-protocols")
        set(proto-file ${wl-proto-file})
    elseif(EXISTS ${wlr-proto-file})
        message(STATUS "using ${proto} from wlr-protocols")
        set(proto-file ${wlr-proto-file})
    else()
        message(STATUS "error: protocol ${proto} not found")
        set(protocols-found FALSE)
    endif()

    set(proto-header "${CMAKE_CURRENT_BINARY_DIR}/include/${proto-base}.h")
    set(proto-source "${CMAKE_CURRENT_BINARY_DIR}/src/${proto-base}.c")

    file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/include/")
    file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/src/")
    add_custom_command(
        OUTPUT "${proto-header}"
        MAIN_DEPENDENCY "${proto-file}"
        COMMAND "${WAYLAND_SCANNER}" client-header "${proto-file}" "${proto-header}"
    )
    add_custom_command(
        OUTPUT "${proto-source}"
        MAIN_DEPENDENCY "${proto-file}"
        COMMAND "${WAYLAND_SCANNER}" private-code "${proto-file}" "${proto-source}"
    )
    add_custom_target(gen-${proto-base} DEPENDS "${proto-header}" "${proto-source}")

    set_source_files_properties("${proto-header}" PROPERTIES GENERATED 1)
    set_source_files_properties("${proto-source}" PROPERTIES GENERATED 1)

    add_dependencies(protocols gen-${proto-base})
    target_sources(protocols PRIVATE "${proto-source}")
endforeach()

if(NOT ${protocols-found})
    message(FATAL_ERROR "some protocols could not be found")
endif()

=== version/CMakeLists.txt ===
add_library(version INTERFACE)
target_include_directories(version INTERFACE "${CMAKE_CURRENT_BINARY_DIR}/include/")

set(version-header "${CMAKE_CURRENT_BINARY_DIR}/include/version.h")
set(version-template "${CMAKE_CURRENT_SOURCE_DIR}/version.h.in")

add_custom_target(gen-version
    COMMAND "${CMAKE_COMMAND}" "-DREPO_DIR=${CMAKE_SOURCE_DIR}" -P "${CMAKE_CURRENT_SOURCE_DIR}/version.cmake" "${version-header}" "${version-template}"
)

set_source_files_properties("${version-header}" PROPERTIES GENERATED 1)
add_dependencies(version gen-version)

=== debian/changelog ===
wl-mirror (0.16.1-1) unstable; urgency=medium

  * Fixed regions being incorrectly applied on outputs with fractional scale

 -- Ferdinand Bachmann <ferdinand.bachmann@yrlf.at>  Fri, 02 Feb 2024 14:46:19 +0100

wl-mirror (0.16.0-1) unstable; urgency=medium

  * Implemented fractional scale support
  * Made scaling and scaling filter options independent
  * Added --scaling cover option for cropping image to fit
  * Changed --scaling exact to also perform exact multiple downscaling

 -- Ferdinand Bachmann <ferdinand.bachmann@yrlf.at>  Tue, 23 Jan 2024 17:25:34 +0100

wl-mirror (0.15.0-1) unstable; urgency=medium

  * Updated wayland-protocols to 1.32 and wlr-protocols to the latest version
  * Fixed some build system issues where changed files would not get rebuilt
  * Added --fullscreen and --fullscreen-output options for starting wl-mirror
    in fullscreen and setting the output to fullscreen to

 -- Ferdinand Bachmann <ferdinand.bachmann@yrlf.at>  Thu, 28 Dec 2023 20:39:38 +0100

wl-mirror (0.14.2-1) unstable; urgency=medium

  * Fixed unclear licensing terms in the README. This project is now licensed
    as GPL-3.0-or-later

 -- Ferdinand Bachmann <ferdinand.bachmann@yrlf.at>  Fri, 27 Oct 2023 14:02:58 +0200

wl-mirror (0.14.1-1) unstable; urgency=medium

  * Performed some refactors in preparation for XDG Desktop Portal Support
  * Fixed potentially incorrect rendering when the image contains an alpha
    channel
  * Fixed an incorrect log message in the screencopy backend
  * Clarified when scdoc is required in the README

 -- Ferdinand Bachmann <ferdinand.bachmann@yrlf.at>  Thu, 26 Oct 2023 14:13:08 +0200

=== debian/control ===
Source: wl-mirror
Section: x11
Priority: optional
Maintainer: Ferdinand Bachmann <ferdinand.bachmann@yrlf.at>
Build-Depends: debhelper-compat (= 13), dh-cmake, cmake (>= 3.18), scdoc (>= 1.11.2) <!nodoc>, pkg-config, libwayland-dev, libgles-dev
Standards-Version: 4.6.2
Homepage: https://github.com/Ferdi265/wl-mirror
Vcs-Browser: https://github.com/Ferdi265/wl-mirror-debian
Vcs-Git: https://github.com/Ferdi265/wl-mirror-debian.git
Rules-Requires-Root: no

Package: wl-mirror
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: output-mirroring tool for wlroots-based Wayland desktops
 wl-mirror is a tool to add output mirroring to sway and other wlroots-based
 Wayland compositors. wl-mirror requires the export-dmabuf or screencopy
 protocols to work.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,-z,defs

%:
	dh $@ --buildsystem=cmake

ifneq ($(filter nodoc,$(DEB_BUILD_PROFILES)),)
DOCS=OFF
else
DOCS=ON
endif

override_dh_auto_configure:
	dh_auto_configure -- \
		-DBUILD_DOCUMENTATION=$(DOCS) \
		-DINSTALL_DOCUMENTATION=$(DOCS) \
		$(NULL)

=== debian/watch ===
version=4
opts="\
    searchmode=plain, \
    pgpsigurlmangle=s%$%.sig%" \
https://api.github.com/repos/Ferdi265/@PACKAGE@/releases https://github.com/Ferdi265/@PACKAGE@/releases/download/v@ANY_VERSION@/@PACKAGE@-(?:\d[\-+\.:\~\da-zA-Z]*)@ARCHIVE_EXT@

## wl-mirror 0.16.4

=== debian/changelog ===
wl-mirror (0.16.4-1) unstable; urgency=medium

  * Allow specifying additional options after wl-present mirror. This allows
    starting wl-mirror directly in fullscreen via wl-present, e.g. wl-present
    mirror --fullscreen-output HDMI-A-1 --fullscreen.
  * Allow overriding slurp in wl-present via WL_PRESENT_SLURP environment
    variable.
  * Automatically detect fuzzel as a dmenu replacement in wl-present
  * Add kanshi configuration example to README
  * Update wl-present man page

 -- Ferdinand Bachmann <ferdinand.bachmann@yrlf.at>  Mon, 1 Jul 2024 15:40:01 +0200

wl-mirror (0.16.3-1) unstable; urgency=medium

  * Fixed wl-mirror crashing when more than one seat exists in the session
  * Simplified handling of WL_PRESENT_DMENU in wl-present
  * Added unset-region and unfullscreen options to wl-present

 -- Ferdinand Bachmann <ferdinand.bachmann@yrlf.at>  Thu, 13 Jun 2024 20:09:40 +0200

wl-mirror (0.16.2-2) unstable; urgency=medium

  * Fixed the wl-present package description breaking the guidelines on binary
    package descriptions (Closes: #1067597)

 -- Ferdinand Bachmann <ferdinand.bachmann@yrlf.at>  Sun, 24 Mar 2024 11:30:20 +0100

wl-mirror (0.16.2-1) unstable; urgency=medium

  * Added wl-present, a script for managing presentation sessions with
    wl-mirror that allows interactive control of the output or region that is
    mirrored (Closes: #1065245)

 -- Ferdinand Bachmann <ferdinand.bachmann@yrlf.at>  Sat, 02 Mar 2024 13:09:22 +0100

## wl-mirror 0.16.5

=== debian/changelog ===
wl-mirror (0.16.5-1) unstable; urgency=medium

  * Fix wl-mirror consuming 100% CPU on one core when using the --stream (or
    -S) option. Since wl-present uses the stream option, this also affected
    wl-present usage.

 -- Ferdinand Bachmann <ferdinand.bachmann@yrlf.at>  Fri, 19 Jul 2024 16:22:52 +0200

=== debian/control ===
Source: wl-mirror
Section: x11
Priority: optional
Maintainer: Ferdinand Bachmann <ferdinand.bachmann@yrlf.at>
Build-Depends: debhelper-compat (= 13), dh-cmake, cmake (>= 3.18), scdoc (>= 1.11.2) <!nodoc>, pkgconf, libwayland-dev, libgles-dev
Standards-Version: 4.6.2
Homepage: https://github.com/Ferdi265/wl-mirror
Vcs-Browser: https://github.com/Ferdi265/wl-mirror-debian
Vcs-Git: https://github.com/Ferdi265/wl-mirror-debian.git
Rules-Requires-Root: no

Package: wl-mirror
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: wl-present
Description: output-mirroring tool for wlroots-based Wayland desktops
 wl-mirror is a tool to add output mirroring to sway and other wlroots-based
 Wayland compositors. wl-mirror requires the export-dmabuf or screencopy
 protocols to work.

Package: wl-present
Architecture: all
Depends: wl-mirror, bash (>= 5.2), slurp, wofi | wmenu | rofi | dmenu, ${misc:Depends}
Recommends: pipectl
Description: command-line tool for managing wl-mirror presentation sessions
 wl-present is a command-line tool for managing wl-mirror presentation
 sessions. wl-present allows interactive control of the output or region that
 is mirrored in wl-mirror.

=== debian/rules ===
--- 
+++ 
@@ -16,4 +16,5 @@
 	dh_auto_configure -- \
 		-DBUILD_DOCUMENTATION=$(DOCS) \
 		-DINSTALL_DOCUMENTATION=$(DOCS) \
+		-DINSTALL_EXAMPLE_SCRIPTS=ON \
 		$(NULL)

## wl-mirror 0.17.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,6 +6,8 @@
 # options
 option(INSTALL_EXAMPLE_SCRIPTS "install wl-mirror example scripts" OFF)
 option(INSTALL_DOCUMENTATION "install wl-mirror manual pages" OFF)
+option(WITH_LIBDECOR "use libdecor for window decoration" OFF)
+set(FORCE_WAYLAND_SCANNER_PATH "" CACHE STRING "provide a custom path for wayland-scanner")
 
 # wayland protocols needed by wl-mirror
 option(FORCE_SYSTEM_WL_PROTOCOLS "force use of system wayland-protocols" OFF)

=== deps/CMakeLists.txt ===
--- 
+++ 
@@ -18,9 +18,14 @@
 pkg_check_modules(WaylandEGL REQUIRED IMPORTED_TARGET "wayland-egl")
 pkg_check_modules(EGL REQUIRED IMPORTED_TARGET "egl")
 pkg_check_modules(GLESv2 REQUIRED IMPORTED_TARGET "glesv2")
-pkg_check_modules(WaylandScanner REQUIRED "wayland-scanner")
-pkg_get_variable(WAYLAND_SCANNER "wayland-scanner" "wayland_scanner")
-set(WAYLAND_SCANNER "${WAYLAND_SCANNER}" PARENT_SCOPE)
+
+if ("${FORCE_WAYLAND_SCANNER_PATH}" STREQUAL "")
+    pkg_check_modules(WaylandScanner REQUIRED "wayland-scanner")
+    pkg_get_variable(WAYLAND_SCANNER "wayland-scanner" "wayland_scanner")
+    set(WAYLAND_SCANNER "${WAYLAND_SCANNER}" PARENT_SCOPE)
+else()
+    set(WAYLAND_SCANNER "${FORCE_WAYLAND_SCANNER_PATH}" PARENT_SCOPE)
+endif()
 
 # man dependencies
 if (${INSTALL_DOCUMENTATION})
@@ -48,3 +53,9 @@
     pkg_check_modules(EPoll REQUIRED IMPORTED_TARGET "epoll-shim")
     target_link_libraries(deps INTERFACE PkgConfig::EPoll)
 endif()
+
+if(${WITH_LIBDECOR})
+    pkg_check_modules(LibDecor REQUIRED IMPORTED_TARGET "libdecor-0")
+    target_link_libraries(deps INTERFACE PkgConfig::LibDecor)
+    target_compile_definitions(deps INTERFACE WITH_LIBDECOR)
+endif()

=== proto/CMakeLists.txt ===
--- 
+++ 
@@ -57,7 +57,8 @@
         set(protocols-found FALSE)
     endif()
 
-    set(proto-header "${CMAKE_CURRENT_BINARY_DIR}/include/${proto-base}.h")
+    file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/include/wlm/proto")
+    set(proto-header "${CMAKE_CURRENT_BINARY_DIR}/include/wlm/proto/${proto-base}.h")
     set(proto-source "${CMAKE_CURRENT_BINARY_DIR}/src/${proto-base}.c")
 
     file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/include/")

=== debian/changelog ===
wl-mirror (0.17.0-1) unstable; urgency=medium

  * Add a --title option to allow custom window titles with support for
    placeholders such as {target_output}. Thank you @mazunki!
  * Add support for controlling multiple simultaneous wl-present sessions
    using the WL_PRESENT_PIPE_NAME env var or --name option
  * Improve wl-present behaviour when not having pipectl installed
  * Fix wl-present behaving inconsistently when running multiple sessions at
    once.
  * Upstream release tarballs are now bit-by-bit reproducible from git.

 -- Ferdinand Bachmann <ferdinand.bachmann@yrlf.at>  Mon, 14 Oct 2024 21:52:06 +0200

wl-mirror (0.16.5-2) unstable; urgency=medium

  * Depend on wayland-protocols instead of using the upstream bundled
    wayland-protocols.
  * Fix wayland-protocols and wlr-protocols not being credited in the
    copyright file.

 -- Ferdinand Bachmann <ferdinand.bachmann@yrlf.at>  Fri, 26 Jul 2024 18:03:43 +0200

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: x11
 Priority: optional
 Maintainer: Ferdinand Bachmann <ferdinand.bachmann@yrlf.at>
-Build-Depends: debhelper-compat (= 13), dh-cmake, cmake (>= 3.18), scdoc (>= 1.11.2) <!nodoc>, pkgconf, libwayland-dev, libgles-dev
-Standards-Version: 4.6.2
+Build-Depends: debhelper-compat (= 13), dh-cmake, cmake (>= 3.18), scdoc (>= 1.11.2) <!nodoc>, pkgconf, wayland-protocols, libwayland-dev, libgles-dev
+Standards-Version: 4.7.0
 Homepage: https://github.com/Ferdi265/wl-mirror
 Vcs-Browser: https://github.com/Ferdi265/wl-mirror-debian
 Vcs-Git: https://github.com/Ferdi265/wl-mirror-debian.git

=== debian/rules ===
--- 
+++ 
@@ -14,6 +14,7 @@
 
 override_dh_auto_configure:
 	dh_auto_configure -- \
+		-DFORCE_SYSTEM_WL_PROTOCOLS=ON \
 		-DBUILD_DOCUMENTATION=$(DOCS) \
 		-DINSTALL_DOCUMENTATION=$(DOCS) \
 		-DINSTALL_EXAMPLE_SCRIPTS=ON \

## wl-mirror 0.18.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,6 +7,7 @@
 option(INSTALL_EXAMPLE_SCRIPTS "install wl-mirror example scripts" OFF)
 option(INSTALL_DOCUMENTATION "install wl-mirror manual pages" OFF)
 option(WITH_LIBDECOR "use libdecor for window decoration" OFF)
+option(WITH_GBM "use GBM and libdrm for dmabuf allocation" OFF)
 set(FORCE_WAYLAND_SCANNER_PATH "" CACHE STRING "provide a custom path for wayland-scanner")
 
 # wayland protocols needed by wl-mirror
@@ -18,6 +19,9 @@
     "stable/xdg-shell/xdg-shell.xml"
     "stable/viewporter/viewporter.xml"
     "staging/fractional-scale/fractional-scale-v1.xml"
+    "staging/ext-image-copy-capture/ext-image-copy-capture-v1.xml"
+    "staging/ext-image-capture-source/ext-image-capture-source-v1.xml"
+    "staging/ext-foreign-toplevel-list/ext-foreign-toplevel-list-v1.xml"
     "unstable/xdg-output/xdg-output-unstable-v1.xml"
     "unstable/linux-dmabuf/linux-dmabuf-unstable-v1.xml"
     "unstable/wlr-export-dmabuf-unstable-v1.xml"
@@ -44,7 +48,7 @@
 endif()
 
 # main target
-file(GLOB sources CONFIGURE_DEPENDS src/*.c)
+file(GLOB_RECURSE sources CONFIGURE_DEPENDS src/*.c)
 add_executable(wl-mirror ${sources})
 target_compile_options(wl-mirror PRIVATE -Wall -Wextra)
 target_include_directories(wl-mirror PRIVATE include/)

=== deps/CMakeLists.txt ===
--- 
+++ 
@@ -59,3 +59,10 @@
     target_link_libraries(deps INTERFACE PkgConfig::LibDecor)
     target_compile_definitions(deps INTERFACE WITH_LIBDECOR)
 endif()
+
+if(${WITH_GBM})
+    pkg_check_modules(GBM REQUIRED IMPORTED_TARGET "gbm")
+    pkg_check_modules(LibDRM REQUIRED IMPORTED_TARGET "libdrm")
+    target_link_libraries(deps INTERFACE PkgConfig::GBM PkgConfig::LibDRM)
+    target_compile_definitions(deps INTERFACE WITH_GBM WITH_LIBDRM)
+endif()

=== glsl/CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,12 @@
 add_library(shaders STATIC)
-target_include_directories(shaders INTERFACE "${CMAKE_CURRENT_BINARY_DIR}/include/")
+target_include_directories(shaders PUBLIC "${CMAKE_CURRENT_BINARY_DIR}/include/")
 file(GLOB shaders CONFIGURE_DEPENDS "*.glsl")
 foreach(shader ${shaders})
     get_filename_component(shader-base "${shader}" NAME_WE)
 
+    file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/include/wlm/glsl")
     set(shader-template "${CMAKE_CURRENT_SOURCE_DIR}/embed.c.in")
-    set(shader-header "${CMAKE_CURRENT_BINARY_DIR}/include/glsl_${shader-base}.h")
+    set(shader-header "${CMAKE_CURRENT_BINARY_DIR}/include/wlm/glsl/${shader-base}.h")
     set(shader-source "${CMAKE_CURRENT_BINARY_DIR}/src/glsl_${shader-base}.c")
 
     message(STATUS "embedding ${shader-base}.glsl")
@@ -13,6 +14,7 @@
     add_custom_command(
         OUTPUT "${shader-source}"
         MAIN_DEPENDENCY "${shader}"
+        DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/embed.cmake" "${shader-template}"
         COMMAND "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_SOURCE_DIR}/embed.cmake" "${shader}" "${shader-template}" "${shader-source}"
     )
     add_custom_target(gen-${shader-base} DEPENDS "${shader-source}")

=== man/CMakeLists.txt ===
--- 
+++ 
@@ -12,6 +12,7 @@
     set(man-bin "${CMAKE_BINARY_DIR}/man/${name}.${section}")
     add_custom_command(
         OUTPUT "${man-bin}"
+        MAIN_DEPENDENCY "${man-src}"
         COMMAND "${SCDOC}" < "${man-src}" > "${man-bin}"
     )
     add_custom_target(gen-man-${name}-${section} ALL DEPENDS "${man-bin}")

=== version/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,8 @@
 add_library(version INTERFACE)
 target_include_directories(version INTERFACE "${CMAKE_CURRENT_BINARY_DIR}/include/")
 
-set(version-header "${CMAKE_CURRENT_BINARY_DIR}/include/version.h")
+file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/include/wlm")
+set(version-header "${CMAKE_CURRENT_BINARY_DIR}/include/wlm/version.h")
 set(version-template "${CMAKE_CURRENT_SOURCE_DIR}/version.h.in")
 
 add_custom_target(gen-version

=== debian/changelog ===
wl-mirror (0.18.0-1) unstable; urgency=medium

  * Add a new screencopy-dmabuf backent that uses DMA-BUFs instead of shared
    memory.
  * Changed the screencopy backend to automatically choose screencopy-dmabuf
    over screencopy-shm when available.
  * Added new extcopy-dmabuf and extcopy-shm backends that use
    ext-image-copy-capture-v1.
  * Also added an extcopy backend that automatically chooses extcopy-dmabuf
    over extcopy-shm when available.
  * Fix a potential use-after-free when using --title together with --stream.
    Thank you @danielrainer!
  * Rework stream input handling to be less error-prone. Thank you
    @danielrainer!
  * Fixed missing man-page documentation for --title.
  * Added a dependency on libdrm and libgbm for DMA-BUF allocation.
  * Enabled libdecor for decoration on compositors without server-side
    decoration.

 -- Ferdinand Bachmann <ferdinand.bachmann@yrlf.at>  Thu, 13 Mar 2025 16:34:52 +0100

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: x11
 Priority: optional
 Maintainer: Ferdinand Bachmann <ferdinand.bachmann@yrlf.at>
-Build-Depends: debhelper-compat (= 13), dh-cmake, cmake (>= 3.18), scdoc (>= 1.11.2) <!nodoc>, pkgconf, wayland-protocols, libwayland-dev, libgles-dev
+Build-Depends: debhelper-compat (= 13), dh-cmake, cmake (>= 3.18), scdoc (>= 1.11.2) <!nodoc>, pkgconf, wayland-protocols, libwayland-dev, libgles-dev, libdecor-0-dev, libdrm-dev, libgbm-dev
 Standards-Version: 4.7.0
 Homepage: https://github.com/Ferdi265/wl-mirror
 Vcs-Browser: https://github.com/Ferdi265/wl-mirror-debian

=== debian/rules ===
--- 
+++ 
@@ -15,6 +15,8 @@
 override_dh_auto_configure:
 	dh_auto_configure -- \
 		-DFORCE_SYSTEM_WL_PROTOCOLS=ON \
+		-DWITH_LIBDECOR=ON \
+		-DWITH_GBM=ON \
 		-DBUILD_DOCUMENTATION=$(DOCS) \
 		-DINSTALL_DOCUMENTATION=$(DOCS) \
 		-DINSTALL_EXAMPLE_SCRIPTS=ON \

=== debian/watch ===
version=4
opts="\
    searchmode=plain, \
    pgpsigurlmangle=s%$%.sig%" \
https://api.github.com/repos/Ferdi265/@PACKAGE@/releases https://github.com/Ferdi265/@PACKAGE@/releases/download/v@ANY_VERSION@/@PACKAGE@-(?:\d[\-+\.:\~\da-zA-Z]*)-nowlp@ARCHIVE_EXT@

## wl-mirror 0.18.4

=== glsl/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 add_library(shaders STATIC)
-target_include_directories(shaders PUBLIC "${CMAKE_CURRENT_BINARY_DIR}/include/")
+target_include_directories(shaders PUBLIC "${CMAKE_CURRENT_BINARY_DIR}/include")
 file(GLOB shaders CONFIGURE_DEPENDS "*.glsl")
 foreach(shader ${shaders})
     get_filename_component(shader-base "${shader}" NAME_WE)

=== proto/CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 set(wl-protocols-found FALSE)
 if(NOT ${FORCE_SYSTEM_WL_PROTOCOLS} AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/wayland-protocols/.git")
     message(STATUS "using wayland-protocols from submodule")
-    set(WL_PROTOCOL_DIR "${CMAKE_CURRENT_SOURCE_DIR}/wayland-protocols/")
+    set(WL_PROTOCOL_DIR "${CMAKE_CURRENT_SOURCE_DIR}/wayland-protocols")
     set(wl-protocols-found TRUE)
 endif()
 
@@ -19,7 +19,7 @@
 set(wlr-protocols-found FALSE)
 if(NOT ${FORCE_SYSTEM_WLR_PROTOCOLS} AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/wlr-protocols/.git")
     message(STATUS "using wlr-protocols from submodule")
-    set(WLR_PROTOCOL_DIR "${CMAKE_CURRENT_SOURCE_DIR}/wlr-protocols/")
+    set(WLR_PROTOCOL_DIR "${CMAKE_CURRENT_SOURCE_DIR}/wlr-protocols")
     set(wlr-protocols-found TRUE)
 endif()
 
@@ -39,7 +39,7 @@
 # wayland protocol wrapper generation with wayland-scanner
 set(protocols-found TRUE)
 add_library(protocols STATIC)
-target_include_directories(protocols INTERFACE "${CMAKE_CURRENT_BINARY_DIR}/include/")
+target_include_directories(protocols INTERFACE "${CMAKE_CURRENT_BINARY_DIR}/include")
 target_link_libraries(protocols PRIVATE proto_deps)
 foreach(proto ${PROTOCOLS})
     get_filename_component(proto-base "${proto}" NAME_WE)
@@ -61,8 +61,8 @@
     set(proto-header "${CMAKE_CURRENT_BINARY_DIR}/include/wlm/proto/${proto-base}.h")
     set(proto-source "${CMAKE_CURRENT_BINARY_DIR}/src/${proto-base}.c")
 
-    file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/include/")
-    file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/src/")
+    file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/include")
+    file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/src")
     add_custom_command(
         OUTPUT "${proto-header}"
         MAIN_DEPENDENCY "${proto-file}"

=== debian/changelog ===
wl-mirror (0.18.4-1) unstable; urgency=medium

  * Fixed wl-mirror exiting with an error when no libdecor decoration plugins
    are installed. (Closes: #1126515)
  * Fixed custom titles from --title only applying after the window is created
    and not during initial configure.
  * Fix wl-mirror crashing on some compositors with wp_viewport error "source
    rectangle out of buffer bounds"

 -- Ferdinand Bachmann <ferdinand.bachmann@yrlf.at>  Sun, 01 Feb 2026 16:49:00 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Ferdinand Bachmann <ferdinand.bachmann@yrlf.at>
 Build-Depends: debhelper-compat (= 13), dh-cmake, cmake (>= 3.18), scdoc (>= 1.11.2) <!nodoc>, pkgconf, wayland-protocols, libwayland-dev, libgles-dev, libdecor-0-dev, libdrm-dev, libgbm-dev
-Standards-Version: 4.7.0
+Standards-Version: 4.7.3
 Homepage: https://github.com/Ferdi265/wl-mirror
 Vcs-Browser: https://github.com/Ferdi265/wl-mirror-debian
 Vcs-Git: https://github.com/Ferdi265/wl-mirror-debian.git
@@ -12,7 +12,7 @@
 Package: wl-mirror
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Recommends: wl-present
+Recommends: wl-present, libdecor-0-plugin-1-gtk | libdecor-0-plugin-1-cairo
 Description: output-mirroring tool for wlroots-based Wayland desktops
  wl-mirror is a tool to add output mirroring to sway and other wlroots-based
  Wayland compositors. wl-mirror requires the export-dmabuf or screencopy

## wl-mirror 0.18.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -13,8 +13,8 @@
 # wayland protocols needed by wl-mirror
 option(FORCE_SYSTEM_WL_PROTOCOLS "force use of system wayland-protocols" OFF)
 option(FORCE_SYSTEM_WLR_PROTOCOLS "force use of system wlr-protocols" OFF)
-set(WL_PROTOCOL_DIR "/usr/share/wayland-protocols/" CACHE STRING "wayland-protocols directory")
-set(WLR_PROTOCOL_DIR "/usr/share/wlr-protocols/" CACHE STRING "wlr-protocols directory")
+set(WL_PROTOCOL_DIR "/usr/share/wayland-protocols" CACHE STRING "wayland-protocols directory")
+set(WLR_PROTOCOL_DIR "/usr/share/wlr-protocols" CACHE STRING "wlr-protocols directory")
 set(PROTOCOLS
     "stable/xdg-shell/xdg-shell.xml"
     "stable/viewporter/viewporter.xml"

=== man/CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,7 @@
 
 
 function(build_scdoc_man_page name section)
-    file(MAKE_DIRECTORY "${CMAKE_BINARY_DIR}/man/")
+    file(MAKE_DIRECTORY "${CMAKE_BINARY_DIR}/man")
     set(man-src "${CMAKE_SOURCE_DIR}/man/${name}.${section}.scd")
     set(man-bin "${CMAKE_BINARY_DIR}/man/${name}.${section}")
     add_custom_command(
@@ -20,5 +20,5 @@
 
 function(install_scdoc_man_page name section)
     set(man-bin "${CMAKE_BINARY_DIR}/man/${name}.${section}")
-    install(FILES "${man-bin}" DESTINATION "${CMAKE_INSTALL_MANDIR}/man${section}/")
+    install(FILES "${man-bin}" DESTINATION "${CMAKE_INSTALL_MANDIR}/man${section}")
 endfunction()

=== version/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 add_library(version INTERFACE)
-target_include_directories(version INTERFACE "${CMAKE_CURRENT_BINARY_DIR}/include/")
+target_include_directories(version INTERFACE "${CMAKE_CURRENT_BINARY_DIR}/include")
 
 file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/include/wlm")
 set(version-header "${CMAKE_CURRENT_BINARY_DIR}/include/wlm/version.h")

=== debian/changelog ===
wl-mirror (0.18.5-1) unstable; urgency=medium

  * Fixed wl-mirror exiting with an error when initial surface configure takes
    too long.

 -- Ferdinand Bachmann <ferdinand.bachmann@yrlf.at>  Mon, 09 Feb 2026 23:37:17 +0100

=== debian/watch ===
Version: 5
Source: https://api.github.com/repos/Ferdi265/@PACKAGE@/releases
Matching-Pattern: https://github.com/Ferdi265/@PACKAGE@/releases/download/v@ANY_VERSION@/@PACKAGE@-(?:\d[\-+\.:\~\da-zA-Z]*)-nowlp@ARCHIVE_EXT@
Search-Mode: plain
Pgp-Sig-Url-Mangle: s%$%.sig%
